﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using FluentAssertions;
using System.Reactive.Linq;

namespace xReactor.Tests
{
    [TestClass]
    public class PropertyStreamTests : PropertyTestBase
    {
        [TestMethod]
        public void SubscriberGetsNotified()
        {
            var room = CreateRoom();
            string receivedValue = null;
            room.NameProperty.GetStream().Subscribe((str) => receivedValue = str);

            room.Name = "Mario's room";
            receivedValue.Should().Be("Mario's room", "subscriber should have received exactly this data");
        }

        [TestMethod]
        public void DisposedSubscriberDoesNotGetNotified()
        {
            var room = CreateRoom();
            string receivedValue = null;
            var subscription = room.NameProperty.GetStream().Subscribe((str) => receivedValue = str);
            subscription.Dispose();
            room.Name = "Mario's room";
            receivedValue.Should().Be(null, "subscriber should not have received any data (it's disposed)");
        }
    }
}
