﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace xReactor
{
    abstract public class NotifyPropertyChangedBase : INotifyPropertyChanged
    {
        #region INPC implementation

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(sender, e);
            }
        }

        protected void RaisePropertyChanged<T>(Expression<Func<T>> nameExpression)
        {
            string propertyName = ExpressionHelper.GetNameFromExpression(nameExpression);
            RaisePropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
